## Index

### Classes

- AsyncHierarchyQuery
- AsyncOrderedHierarchyQuery
- AsyncOrderedQuery
- AsyncQuery
- HierarchyQuery
- Lazy
- Lookup
- OrderedHierarchyQuery
- OrderedQuery
- Query

### Interfaces

- AsyncHierarchyIterable
- AsyncOrderedHierarchyIterable
- AsyncOrderedIterable
- Grouping
- Hierarchical
- HierarchyGrouping
- HierarchyIterable
- HierarchyPage
- HierarchyProvider
- OrderedHierarchyIterable
- OrderedIterable
- Page
- WritableArrayLike

### Type aliases

- AsyncChoice
- AsyncHierarchyQueryFlow
- AsyncOrderedQueryFlow
- AsyncQueryFlow
- AsyncQueryable
- AsyncUnorderedQueryFlow
- Choice
- HierarchyQueryFlow
- KeyValuePair
- OrderedQueryFlow
- PossiblyAsyncHierarchyIterable
- PossiblyAsyncIterable
- PossiblyAsyncOrderedHierarchyIterable
- PossiblyAsyncOrderedIterable
- QueriedType
- QueryFlow
- Queryable
- UnorderedQueryFlow

### Functions

- from
- fromAsync

## Type aliases

### AsyncChoice

AsyncChoice: [PromiseLike<K> | K, AsyncQueryable<V>]

- Defined in types.ts:213

### AsyncHierarchyQueryFlow

AsyncHierarchyQueryFlow: AsyncHierarchyQueryFlow<S, T>

- Defined in asyncQuery.ts:44

Flows the base type of a Query as a hierarchical query with a new iterated type.

### AsyncOrderedQueryFlow

AsyncOrderedQueryFlow: AsyncOrderedQueryFlow<S, T>

- Defined in asyncQuery.ts:37

Flows the base type of a Query as an ordered query with a new iterated type.

### AsyncQueryFlow

AsyncQueryFlow: AsyncQueryFlow<S, T>

- Defined in asyncQuery.ts:51

Flows the base type of a Query with a new iterated type.

### AsyncQueryable

AsyncQueryable: AsyncIterable<T> | Queryable<PromiseLike<T> | T>

- Defined in types.ts:218

### AsyncUnorderedQueryFlow

AsyncUnorderedQueryFlow: AsyncUnorderedQueryFlow<S, T>

- Defined in asyncQuery.ts:30

Flows the base type of a Query as an unordered query with a new iterated type.

### Choice

Choice: [K, Queryable<V>]

- Defined in types.ts:180

### HierarchyQueryFlow

HierarchyQueryFlow: HierarchyQueryFlow<S, T>

- Defined in query.ts:43

Flows the base type of a Query as a hierarchical query with a new iterated type.

### KeyValuePair

KeyValuePair: KeyValuePair<T, K>

- Defined in types.ts:26

Typed key-value pairs derived from the properties of an `object`.

### OrderedQueryFlow

OrderedQueryFlow: OrderedQueryFlow<S, T>

- Defined in query.ts:36

Flows the base type of a Query as an ordered query with a new iterated type.

### PossiblyAsyncHierarchyIterable

PossiblyAsyncHierarchyIterable: AsyncHierarchyIterable<TNode, T> | HierarchyIterable<TNode, T>

- Defined in types.ts:220

### PossiblyAsyncIterable

PossiblyAsyncIterable: AsyncIterable<T> | Iterable<PromiseLike<T> | T>

- Defined in types.ts:219

### PossiblyAsyncOrderedHierarchyIterable

PossiblyAsyncOrderedHierarchyIterable: AsyncOrderedHierarchyIterable<TNode, T> | OrderedHierarchyIterable<TNode, T>

- Defined in types.ts:222

### PossiblyAsyncOrderedIterable

PossiblyAsyncOrderedIterable: AsyncOrderedIterable<T> | OrderedIterable<T>

- Defined in types.ts:221

### QueriedType

QueriedType: QueriedType<T>

- Defined in types.ts:223

### QueryFlow

QueryFlow: QueryFlow<S, T>

- Defined in query.ts:50

Flows the base type of a Query with a new iterated type.

### Queryable

Queryable: Iterable<T> | ArrayLike<T>

- Defined in types.ts:217

### UnorderedQueryFlow

UnorderedQueryFlow: UnorderedQueryFlow<S, T>

- Defined in query.ts:29

Flows the base type of a Query as an unordered query with a new iterated type.

## Functions

### from

- from<TNode, T>(source: OrderedHierarchyIterable<TNode, T>): OrderedHierarchyQuery<TNode, T>
- from<TNode, T>(source: HierarchyIterable<TNode, T>): HierarchyQuery<TNode, T>
- from<T>(source: OrderedIterable<T>): OrderedQuery<T>
- from<T>(source: Queryable<T>): Query<T>
- from<TNode, T>(source: OrderedIterable<T>, hierarchy: HierarchyProvider<TNode>): OrderedHierarchyQuery<TNode, T>
- from<TNode, T>(source: Queryable<T>, hierarchy: HierarchyProvider<TNode>): HierarchyQuery<TNode, T>

- - Defined in query.ts:59

  Creates a Query from a Queryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: OrderedHierarchyIterable<TNode, T> —

    An OrderedHierarchyIterable object.

  #### Returns OrderedHierarchyQuery<TNode, T>

- - Defined in query.ts:65

  Creates a Query from a Queryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: HierarchyIterable<TNode, T> —

    An OrderedHierarchyIterable object.

  #### Returns HierarchyQuery<TNode, T>

- - Defined in query.ts:71

  Creates a Query from a Queryable source.

  #### Type parameters

  - T

  #### Parameters

  - source: OrderedIterable<T> —

    An OrderedHierarchyIterable object.

  #### Returns OrderedQuery<T>

- - Defined in query.ts:77

  Creates a Query from a Queryable source.

  #### Type parameters

  - T

  #### Parameters

  - source: Queryable<T> —

    An OrderedHierarchyIterable object.

  #### Returns Query<T>

- - Defined in query.ts:84

  Creates a Query from a Queryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: OrderedIterable<T> —

    An OrderedHierarchyIterable object.

  - hierarchy: HierarchyProvider<TNode> —

    A HierarchyProvider object.

  #### Returns OrderedHierarchyQuery<TNode, T>

- - Defined in query.ts:91

  Creates a Query from a Queryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: Queryable<T> —

    An OrderedHierarchyIterable object.

  - hierarchy: HierarchyProvider<TNode> —

    A HierarchyProvider object.

  #### Returns HierarchyQuery<TNode, T>

### fromAsync

- fromAsync<TNode, T>(source: PossiblyAsyncOrderedHierarchyIterable<TNode, T>): AsyncOrderedHierarchyQuery<TNode, T>
- fromAsync<TNode, T>(source: PossiblyAsyncHierarchyIterable<TNode, T>): AsyncHierarchyQuery<TNode, T>
- fromAsync<T>(source: PossiblyAsyncOrderedIterable<T>): AsyncOrderedQuery<T>
- fromAsync<T>(source: AsyncQueryable<T>): AsyncQuery<T>
- fromAsync<TNode, T>(source: PossiblyAsyncOrderedIterable<T>, hierarchy: HierarchyProvider<TNode>): AsyncOrderedHierarchyQuery<TNode, T>
- fromAsync<TNode, T>(source: AsyncQueryable<T>, hierarchy: HierarchyProvider<TNode>): AsyncHierarchyQuery<TNode, T>

- - Defined in asyncQuery.ts:60

  Creates an AsyncQuery from an AsyncQueryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: PossiblyAsyncOrderedHierarchyIterable<TNode, T> —

    An AsyncQueryable object.

  #### Returns AsyncOrderedHierarchyQuery<TNode, T>

- - Defined in asyncQuery.ts:67

  Creates an AsyncQuery from an AsyncQueryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: PossiblyAsyncHierarchyIterable<TNode, T> —

    An AsyncQueryable object.

  #### Returns AsyncHierarchyQuery<TNode, T>

- - Defined in asyncQuery.ts:74

  Creates an AsyncQuery from an AsyncQueryable source.

  #### Type parameters

  - T

  #### Parameters

  - source: PossiblyAsyncOrderedIterable<T> —

    An AsyncQueryable object.

  #### Returns AsyncOrderedQuery<T>

- - Defined in asyncQuery.ts:81

  Creates an AsyncQuery from an AsyncQueryable source.

  #### Type parameters

  - T

  #### Parameters

  - source: AsyncQueryable<T> —

    An AsyncQueryable object.

  #### Returns AsyncQuery<T>

- - Defined in asyncQuery.ts:89

  Creates an `AsyncHierarchyQuery` from an AsyncQueryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: PossiblyAsyncOrderedIterable<T> —

    An AsyncQueryable object.

  - hierarchy: HierarchyProvider<TNode> —

    A `HierarchyProvider` object.

  #### Returns AsyncOrderedHierarchyQuery<TNode, T>

- - Defined in asyncQuery.ts:97

  Creates an `AsyncHierarchyQuery` from an AsyncQueryable source.

  #### Type parameters

  - TNode
  - T: TNode

  #### Parameters

  - source: AsyncQueryable<T> —

    An AsyncQueryable object.

  - hierarchy: HierarchyProvider<TNode> —

    A `HierarchyProvider` object.

  #### Returns AsyncHierarchyQuery<TNode, T>

Generated using TypeDoc